.386
.model flat,stdcall
option casemap:none

include WinSockTest1.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.elseif eax==Serv
		invoke MessageBox,hWnd,CTEXT("Initializing Server..."),CTEXT("Step 1"),MB_OK
		invoke WSAStartup, 101h,addr wsadata ;Startup WinSock32
		.if eax!=NULL 
		    invoke MessageBox,hWnd,CTEXT("Error 1"),CTEXT("Error"),MB_ICONERROR
		.else 
			invoke socket,AF_INET,SOCK_STREAM,0 ; Create a stream socket for internet use 
			.if eax!=INVALID_SOCKET 
			    mov listeningSocket,eax
			    mov sin.sin_family, AF_INET
			    invoke inet_addr, addr IPAddress
			    mov sin.sin_addr, eax
			    invoke htons, Port
			    mov sin.sin_port, ax
			    invoke bind,listeningSocket,addr sin, sizeof sin
			    	.if eax == SOCKET_ERROR
			    		invoke MessageBox,hWnd,CTEXT("Error 7"),CTEXT("Error"),MB_ICONERROR
			    	.endif
			    invoke listen,listeningSocket,5
			    	.if eax == SOCKET_ERROR
			    		invoke MessageBox,hWnd,CTEXT("Error 8"),CTEXT("Error"),MB_ICONERROR
			    	.endif
			    invoke accept,listeningSocket,0,0
			    	.if eax == INVALID_SOCKET
			    		invoke MessageBox,hWnd,CTEXT("Error 9"),CTEXT("Error"),MB_ICONERROR			    		
			    	.endif
			    mov theClient, eax
			    
			    invoke recv,listeningSocket,recv1,1,0
			    .if eax != 0
			    	invoke MessageBox,hWnd,CTEXT("Pop up!"),CTEXT("Error"),MB_ICONERROR
			    .endif
			.else 
			    invoke MessageBox,hWnd,CTEXT("Error 2"),CTEXT("Error"),MB_ICONERROR
			.endif
		.endif	
		
							
		.elseif eax==Client
			invoke WSAStartup, 101h,addr wsadata2 ;Startup WinSock32
			.if eax!=NULL 
			    invoke MessageBox,hWnd,CTEXT("Error 1"),CTEXT("Error"),MB_ICONERROR
			.else 
				invoke socket,AF_INET,SOCK_STREAM,0 ; Create a stream socket for internet use 
				.if eax!=INVALID_SOCKET 
				    mov sock,eax 
						mov sin2.sin_family, AF_INET 
						invoke htons, Port                    ; convert port number into network byte order first 
						mov sin2.sin_port,ax                  ; note that this member is a word-size param. 
						invoke inet_addr, addr IPAddress    ; convert the IP address into network byte order 
						mov sin2.sin_addr,eax 
						invoke connect,listeningSocket,addr sin,sizeof sin 
						.if eax==SOCKET_ERROR            ; assuming we use non-blocking mode, connect 
						                                  ; will always return SOCKET_ERROR 
						    invoke WSAGetLastError            ; retrieve the actual error code 
						    .if eax!=WSAEWOULDBLOCK        ; if it's not WSAEWOULDBLOCK 
						        
						    .endif 
						.endif	
										
				    
				.else 
				    invoke MessageBox,hWnd,CTEXT("Error 2"),CTEXT("Error"),MB_ICONERROR
				.endif
			.endif		
				
		.endif
	.elseif eax==Popup1
		invoke send,sock,TestData,1,0
		.if eax==SOCKET_ERROR
			invoke MessageBox,hWnd,CTEXT("Send didn't work."),CTEXT("Error"),MB_ICONERROR
		.endif
;	.elseif eax==WM_SIZE
	;----------------------------------------------
    .if uMsg==WM_SOCKET            ; the message we specified in WSAAsyncSelect 
        mov eax,lParam 
        .if ax==FD_CONNECT            ; the low word of lParam contains the event code. 
            shr eax,16                              ; the error code (if any) is in the high word of lParam 
            .if ax==NULL 
                ;<no error occurs so proceed> 
            .else 
                invoke MessageBox,hWnd,CTEXT("Error 4"),CTEXT("Error"),MB_ICONERROR
            .endif 
        .elseif    ax==FD_READ 
            shr eax,16 
            .if ax==NULL 
                ;<no error occurs so proceed> 
            .else 
                invoke MessageBox,hWnd,CTEXT("Error 5"),CTEXT("Error"),MB_ICONERROR
            .endif 
        .elseif    ax==FD_CLOSE 
            shr eax,16 
            .if ax==NULL 
                ;<no error occurs so proceed> 
            .else 
                invoke MessageBox,hWnd,CTEXT("Error 6"),CTEXT("Error"),MB_ICONERROR
            .endif 
        .endif 
    .else 
        
    .endif 
    ;----------------------------------------------
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

CreateSocket PROC
	invoke MessageBox,hWnd,CTEXT("Initializing Server..."),CTEXT("Step 1"),MB_OK
		invoke WSAStartup, 101h,addr wsadata ;Startup WinSock32
		.if eax!=NULL 
		    invoke MessageBox,hWnd,CTEXT("Error 1"),CTEXT("Error"),MB_ICONERROR
		.else 
			invoke socket,AF_INET,SOCK_STREAM,0 ; Create a stream socket for internet use 
			.if eax!=INVALID_SOCKET 
			    mov sock,eax 
					invoke WSAAsyncSelect, sock, hWnd,WM_SOCKET, FD_CONNECT+FD_READ+FD_CLOSE 
					            ; Register interest in connect, read and close events. 
					.if eax==SOCKET_ERROR 
					    invoke MessageBox,hWnd,CTEXT("Error 3"),CTEXT("Error"),MB_ICONERROR
					.else 
					    
					.endif 
			    
			.else 
			    invoke MessageBox,hWnd,CTEXT("Error 2"),CTEXT("Error"),MB_ICONERROR
			.endif
		.endif			

	ret

CreateSocket endp
end start
